/*  MakeDataBrowserP.h

    Private header for  MakeDataBrowser  widget class.

    Copyright (C) 2004  Richard Gooch

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*

    This include file contains the private class declarations for the
    MakeDataBrowser widget.


    Written by      Richard Gooch   16-MAR-2004

    Last updated by Richard Gooch   16-MAR-2004

*/
#ifndef MakeDataBrowserP__H
#define MakeDataBrowserP__H

#include <X11/IntrinsicP.h>
#include <X11/ShellP.h>
#include <X11/StringDefs.h>

#if !defined(KARMA_CONSTRUCT_DEF_H) || defined(MAKEDEPEND)
#  include <karma_construct_def.h>
#endif

#include <Xkw/MakeDataBrowser.h>

typedef struct _MakeDataBrowserPart
{
    /*  Public resources  */
    int                     dummy;
    /*  Private resources  */
    KConstructArrayManager  manager;
    Widget                  name_txt;
} MakeDataBrowserPart, *MakeDataBrowserPartPtr;

typedef struct _MakeDataBrowserRec
{
    CorePart core;
    CompositePart composite;
    ShellPart shell;
    WMShellPart wm;
    VendorShellPart vendor;
    TopLevelShellPart topLevel;
    MakeDataBrowserPart makeDataBrowser;
} MakeDataBrowserRec, *MakeDataBrowserPtr;

typedef struct _MakeDataBrowserClassPart
{
    int empty;
} MakeDataBrowserClassPart;

typedef struct _MakeDataBrowserClassRec
{
    CoreClassPart core_class;	
    CompositeClassPart composite_class;
    ShellClassPart shell_class;
    WMShellClassPart wm_shell_class;
    VendorShellClassPart vendor_shell_class;
    TopLevelShellClassPart top_level_shell_class;
    MakeDataBrowserClassPart makeDataBrowser_class;
} MakeDataBrowserClassRec, *MakeDataBrowserClassPtr;

extern MakeDataBrowserClassRec makeDataBrowserClassRec;

#endif
