/*  karma_construct.h

    Header for  construct_  package.

    Copyright (C) 2004  Richard Gooch

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*

    This include file contains all the definitions and function declarations
  needed to interface to the construct_ routines in the Karma library.


    Written by      Richard Gooch   14-MAR-2004

    Last updated by Richard Gooch   31-MAR-2004

*/

#if !defined(KARMA_H) || defined(MAKEDEPEND)
#  include <karma.h>
#endif

#if !defined(KARMA_CONSTRUCT_DEF_H) || defined(MAKEDEPEND)
#  include <karma_construct_def.h>
#endif

#if !defined(KARMA_LISTW_DEF_H) || defined(MAKEDEPEND)
#  include <karma_listw_def.h>
#endif

#ifndef KARMA_CONSTRUCT_H
#define KARMA_CONSTRUCT_H


#define KCONSTRUCTARRAY_ALGORITHM_RGB        0
#define KCONSTRUCTARRAY_ALGORITHM_ADDSUB     1
#define KCONSTRUCTARRAY_NUM_ALGORITHMS       2
extern char *construct_array_algorithm_choices[KCONSTRUCTARRAY_NUM_ALGORITHMS];


/*  File:  array_main.c  */
EXTERN_FUNCTION (KConstructArrayManager construct_array_create_manager,
		 (KListWidget listw, void (*change_name) (), void *info) );
EXTERN_FUNCTION (void construct_array_destroy_manager,
		 (KConstructArrayManager manager) );
EXTERN_FUNCTION (void construct_array_select_algorithm,
		 (KConstructArrayManager manager, unsigned int index) );
EXTERN_FUNCTION (void construct_array_change_name,
		 (KConstructArrayManager manager, CONST char *name) );
EXTERN_FUNCTION (void construct_array_create_data,
		 (KConstructArrayManager manager, CONST char *name) );


#endif /*  KARMA_CONSTRUCT_H  */
