/*  karma_listw.h

    Header for  listw_  package.

    Copyright (C) 2004  Richard Gooch

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Richard Gooch may be reached by email at  karma-request@atnf.csiro.au
    The postal address is:
      Richard Gooch, c/o ATNF, P. O. Box 76, Epping, N.S.W., 2121, Australia.
*/

/*

    This include file contains all the definitions and function declarations
  needed to interface to the listw_ routines in the Karma library.


    Written by      Richard Gooch   7-MAR-2004

    Last updated by Richard Gooch   8-MAR-2004

*/

#if !defined(KARMA_H) || defined(MAKEDEPEND)
#  include <karma.h>
#endif

#if !defined(KARMA_LISTW_DEF_H) || defined(MAKEDEPEND)
#  include <karma_listw_def.h>
#endif

#if !defined(KARMA_KWIN_DEF_H) || defined(MAKEDEPEND)
#  include <karma_kwin_def.h>
#endif

#if !defined(KARMA_C_DEF_H) || defined(MAKEDEPEND)
#  include <karma_c_def.h>
#endif

#ifndef KARMA_LISTW_H
#define KARMA_LISTW_H


/*  List widget attributes  */
#define LISTW_ATT_END                   0   /*  End of varargs list          */
#define LISTW_ATT_NUM_STRINGS           1   /*  (unsigned int)               */
#define LISTW_ATT_STRINGS               2   /*  (char **)                    */
#define LISTW_ATT_TOP_POSITION          3   /*  (unsigned int)               */
#define LISTW_ATT_REVERSE_VIDEO_INDEX   4   /*  (unsigned int)               */
#define LISTW_ATT_HIGHLIGHT_INDEX       5   /*  (unsigned int)               */
#define LISTW_ATT_FOREGROUND_PIXEL      6   /*  (unsigned long)              */
#define LISTW_ATT_HIGHLIGHT_PIXEL       7   /*  (unsigned long)              */
#define LISTW_ATT_MOUSE_MODE            8   /*  (unsigned int)               */
#define LISTW_ATT_SHOWN_FRACTION        9   /*  (double *)                   */

#define LISTW_MOUSE_MODE_NONE           0
#define LISTW_MOUSE_MODE_REVERSE_VIDEO  1
#define LISTW_MOUSE_MODE_HIGHLIGHT      2


/*  File:  main.c  */
EXTERN_FUNCTION (KListWidget listw_create, () );
EXTERN_FUNCTION (void listw_bind, (KListWidget list, KPixCanvas canvas) );
EXTERN_FUNCTION (void listw_destroy, (KListWidget list) );
EXTERN_FUNCTION (KCallbackFunc listw_register_position_event_func,
		 (KListWidget list, flag (*func) (), void *f_info) );
EXTERN_FUNCTION (void listw_get_attributes, (KListWidget list, ...) );
EXTERN_FUNCTION (flag listw_set_attributes,
		 (KListWidget list, flag refresh_if_needed, ...) );
EXTERN_FUNCTION (KCallbackFunc listw_register_att_notify_func,
		 (KListWidget list, void (*func) (), void *info) );


#endif /*  KARMA_LISTW_H  */
